Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 15017)
@@ -48,9 +48,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<ExecPushExpression>();
+
       Eval(
         interpreter.CodeStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new ExecPushExpression(v));
+        v => ExecPushExpression.Create(pool, v));
 
       interpreter.CodeStack.Pop();
@@ -58,5 +60,5 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.DEFINE", StackTypes.Name)]
+  [PushExpression(StackTypes.Exec, "EXEC.DEFINE", StackTypes.Name, execIn: 1)]
   [StorableClass]
   public class ExecDefineExpression : DefineExpression<Expression> {
@@ -71,9 +73,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<ExecPushExpression>();
+
       Eval(
         interpreter.ExecStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new ExecPushExpression(v));
+        v => ExecPushExpression.Create(pool, v));
 
       interpreter.ExecStack.Pop();
@@ -94,9 +98,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<FloatPushExpression>();
+
       Eval(
         interpreter.FloatStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new FloatPushExpression(v));
+        v => FloatPushExpression.Create(pool, v));
     }
   }
@@ -115,9 +121,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<IntegerPushExpression>();
+
       Eval(
         interpreter.IntegerStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new IntegerPushExpression(v));
+        v => IntegerPushExpression.Create(pool, v));
     }
   }
@@ -136,9 +144,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<BooleanPushExpression>();
+
       Eval(
         interpreter.BooleanStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new BooleanPushExpression(v));
+        v => BooleanPushExpression.Create(pool, v));
     }
   }
@@ -157,9 +167,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<CharPushExpression>();
+
       Eval(
         interpreter.CharStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new CharPushExpression(v));
+        v => CharPushExpression.Create(pool, v));
     }
   }
@@ -178,9 +190,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<StringPushExpression>();
+
       Eval(
         interpreter.StringStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new StringPushExpression(v));
+        v => StringPushExpression.Create(pool, v));
     }
   }
@@ -188,5 +202,5 @@
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].DEFINE", StackTypes.Name)]
   [StorableClass]
-  public class IntegerVectorDefineExpression : DefineExpression<List<long>> {
+  public class IntegerVectorDefineExpression : DefineExpression<IReadOnlyList<long>> {
     public IntegerVectorDefineExpression() { }
     [StorableConstructor]
@@ -199,9 +213,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<IntegerVectorPushExpression>();
+
       Eval(
         interpreter.IntegerVectorStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new IntegerVectorPushExpression(v));
+        v => IntegerVectorPushExpression.Create(pool, v));
     }
   }
@@ -209,5 +225,5 @@
   [PushExpression(StackTypes.FloatVector, "FLOAT[].DEFINE", StackTypes.Name)]
   [StorableClass]
-  public class FloatVectorDefineExpression : DefineExpression<List<double>> {
+  public class FloatVectorDefineExpression : DefineExpression<IReadOnlyList<double>> {
     public FloatVectorDefineExpression() { }
     [StorableConstructor]
@@ -220,9 +236,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<FloatVectorPushExpression>();
+
       Eval(
         interpreter.FloatVectorStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new FloatVectorPushExpression(v));
+        v => FloatVectorPushExpression.Create(pool, v));
     }
   }
@@ -230,5 +248,5 @@
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].DEFINE", StackTypes.Name)]
   [StorableClass]
-  public class BooleanVectorDefineExpression : DefineExpression<List<bool>> {
+  public class BooleanVectorDefineExpression : DefineExpression<IReadOnlyList<bool>> {
     public BooleanVectorDefineExpression() { }
     [StorableConstructor]
@@ -241,9 +259,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<BooleanVectorPushExpression>();
+
       Eval(
         interpreter.BooleanVectorStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new BooleanVectorPushExpression(v));
+        v => BooleanVectorPushExpression.Create(pool, v));
     }
   }
@@ -251,5 +271,5 @@
   [PushExpression(StackTypes.StringVector, "STRING[].DEFINE", StackTypes.Name)]
   [StorableClass]
-  public class StringVectorDefineExpression : DefineExpression<List<string>> {
+  public class StringVectorDefineExpression : DefineExpression<IReadOnlyList<string>> {
     public StringVectorDefineExpression() { }
     [StorableConstructor]
@@ -262,9 +282,11 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<BooleanVectorPushExpression>();
+
       Eval(
         interpreter.StringVectorStack,
         interpreter.NameStack,
         interpreter.CustomExpressions,
-        v => new StringVectorPushExpression(v));
+        v => StringVectorPushExpression.Create(pool, v));
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 15017)
@@ -1,111 +1,69 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System;
+  using Attributes;
+  using Interpreter;
+  using Persistence.Default.CompositeSerializers.Storable;
+  using Stack;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+  /// <summary>
+  /// An iteration instruction that performs a loop (the body of which is taken from the CODE stack) the number of times
+  /// indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the
+  /// INTEGER stack prior to each execution of the loop body. This should be implemented as a macro that expands into a call to
+  /// CODE.DO*RANGE. CODE.DO*COUNT takes a single INTEGER argument (the number of times that the loop will be executed) and a single
+  /// CODE argument (the body of the loop). If the provided INTEGER argument is negative or zero then this becomes a NOOP. Otherwise it
+  /// expands into: ( 0 '1 - IntegerArg>' CODE.QUOTE 'CodeArg' CODE.DO*RANGE )
+  /// </summary>
   [Serializable]
   [StorableClass]
-  public abstract class DoCountExpression : LoopExpression {
+  [PushExpression(StackTypes.Code, "CODE.DO*COUNT", StackTypes.Integer)]
+  public class CodeDoCountExpression : StatelessExpression {
 
-    protected DoCountExpression() { }
-    protected DoCountExpression(LoopState state) : base(state) { }
+    public CodeDoCountExpression() { }
     [StorableConstructor]
-    protected DoCountExpression(bool deserializing) : base(deserializing) { }
-    protected override bool HasInsufficientArguments(IInternalPushInterpreter interpreter, IPushStack<Expression> sourceStack) {
-      return interpreter.IntegerStack.Count < 1 ||
-             sourceStack.Count == 0 ||
-             interpreter.IntegerStack.Top <= 0;
+    protected CodeDoCountExpression(bool deserializing) : base(deserializing) { }
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var destinationIndex = interpreter.IntegerStack.Top;
+      interpreter.IntegerStack.Top = 0;
+      interpreter.IntegerStack.Push(destinationIndex);
+
+      interpreter.ExecStack.Push(ExpressionTable.GetStatelessExpression<CodeDoRangeExpression>());
     }
 
-    protected override LoopState InitState(IInternalPushInterpreter interpreter, IPushStack<Expression> sourceStack) {
-      var state = LoopState.Create(interpreter.PoolContainer.LoopStatePool,
-        body: sourceStack.Pop(),
-        currentIndex: 1,
-        destinationIndex: interpreter.IntegerStack.Top,
-        incrementor: 1);
-
-      interpreter.IntegerStack.SetTop(0);
-
-      return state;
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.IntegerStack.IsEmpty ||
+             interpreter.IntegerStack.Top < 1 ||
+             interpreter.CodeStack.IsEmpty;
     }
   }
 
   /// <summary>
-  ///     An iteration instruction that performs a loop (the body of which is taken from the CODE stack) the number of times
-  ///     indicated by
-  ///     the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the
-  ///     INTEGER stack
-  ///     prior to each execution of the loop body. This should be implemented as a macro that expands into a call to
-  ///     CODE.DO*RANGE.
-  ///     CODE.DO*COUNT takes a single INTEGER argument (the number of times that the loop will be executed) and a single
-  ///     CODE argument
-  ///     (the body of the loop). If the provided INTEGER argument is negative or zero then this becomes a NOOP. Otherwise it
-  ///     expands into:
-  ///     ( 0 '1 - IntegerArg>' CODE.QUOTE 'CodeArg' CODE.DO*RANGE )
+  /// An iteration instruction that performs a loop (the body of which is taken from the EXEC stack) the number of times
+  /// indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the
+  /// INTEGER stack prior to each execution of the loop body. This is similar to CODE.DO*COUNT except that it takes its code
+  /// argument from the EXEC stack. This should be implemented as a macro that expands into a call to EXEC.DO*RANGE. EXEC.DO*COUNT
+  /// takes a single INTEGER argument (the number of times that the loop will be executed) and a single EXEC argument (the body of the
+  /// loop). If the provided INTEGER argument is negative or zero then this becomes a NOOP. Otherwise it expands into:
+  /// ( 0 '1 - IntegerArg' EXEC.DO* RANGE'ExecArg' )
   /// </summary>
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.DO*COUNT", StackTypes.Integer)]
-  public class CodeDoCountExpression : DoCountExpression {
-
-    public CodeDoCountExpression() { }
-    public CodeDoCountExpression(LoopState state) : base(state) { }
-    [StorableConstructor]
-    protected CodeDoCountExpression(bool deserializing) : base(deserializing) { }
-    public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return State.Body == null && HasInsufficientArguments(interpreter, interpreter.CodeStack);
-    }
-
-    public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.CodeStack);
-    }
-
-    protected override LoopExpression Clone(LoopState state, IInternalPushInterpreter interpreter) {
-      var expression = interpreter.PoolContainer.GetStatefulExpression<CodeDoCountExpression>();
-      expression.State = state;
-
-      return expression;
-    }
-  }
-
-  /// <summary>
-  ///     An iteration instruction that performs a loop (the body of which is taken from the EXEC stack) the number of times
-  ///     indicated
-  ///     by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the
-  ///     INTEGER
-  ///     stack prior to each execution of the loop body. This is similar to CODE.DO*COUNT except that it takes its code
-  ///     argument from
-  ///     the EXEC stack. This should be implemented as a macro that expands into a call to EXEC.DO*RANGE. EXEC.DO*COUNT
-  ///     takes a single
-  ///     INTEGER argument (the number of times that the loop will be executed) and a single EXEC argument (the body of the
-  ///     loop). If
-  ///     the provided INTEGER argument is negative or zero then this becomes a NOOP. Otherwise it expands into:
-  ///     ( 0 '1 - IntegerArg' EXEC.DO* RANGE'ExecArg' )
-  /// </summary>
-  [Serializable]
-  [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DO*COUNT", StackTypes.Integer)]
-  public class ExecDoCountExpression : DoCountExpression {
+  [PushExpression(StackTypes.Exec, "EXEC.DO*COUNT", StackTypes.Integer, execIn: 1)]
+  public class ExecDoCountExpression : StatelessExpression {
     public ExecDoCountExpression() { }
-    public ExecDoCountExpression(LoopState state) : base(state) { }
     [StorableConstructor]
     protected ExecDoCountExpression(bool deserializing) : base(deserializing) { }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.ExecStack);
+      var destinationIndex = interpreter.IntegerStack.Top;
+      interpreter.IntegerStack.Top = 0;
+      interpreter.IntegerStack.Push(destinationIndex);
+
+      interpreter.ExecStack.Push(ExpressionTable.GetStatelessExpression<ExecDoRangeExpression>());
     }
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return State.Body == null && HasInsufficientArguments(interpreter, interpreter.ExecStack);
-    }
-
-    protected override LoopExpression Clone(LoopState state, IInternalPushInterpreter interpreter) {
-      var expression = interpreter.PoolContainer.GetStatefulExpression<ExecDoCountExpression>();
-      expression.State = state;
-
-      return expression;
+      return interpreter.IntegerStack.IsEmpty ||
+             interpreter.IntegerStack.Top < 1 ||
+             interpreter.ExecStack.IsEmpty;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 15017)
@@ -1,82 +1,58 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System;
-
   using Attributes;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
   using Interpreter;
+  using Persistence.Default.CompositeSerializers.Storable;
   using Stack;
 
-  [Serializable]
-  [StorableClass]
-  public abstract class DoRangeExpression : LoopExpression {
-    protected DoRangeExpression() { }
-    protected DoRangeExpression(LoopState state) : base(state) { }
-    [StorableConstructor]
-    protected DoRangeExpression(bool deserializing) : base(deserializing) { }
-
-    protected override bool HasInsufficientArguments(IInternalPushInterpreter interpreter, IPushStack<Expression> sourceStack) {
-      return interpreter.IntegerStack.Count < 2 ||
-             sourceStack.Count == 0 ||
-             interpreter.IntegerStack.Top == interpreter.IntegerStack[1];
-    }
-
-    protected override LoopState InitState(IInternalPushInterpreter interpreter, IPushStack<Expression> sourceStack) {
-      var destinationIndex = interpreter.IntegerStack.Pop();
-      var incrementor = destinationIndex < interpreter.IntegerStack.Top ? -1 : 1;
-
-      return LoopState.Create(interpreter.PoolContainer.LoopStatePool,
-          body: sourceStack.Pop(),
-          currentIndex: interpreter.IntegerStack.Top + incrementor,
-          destinationIndex: destinationIndex,
-          incrementor: incrementor);
-    }
-  }
-
   /// <summary>
-  ///     An iteration instruction that executes the top item on the CODE stack a number of times that depends on the
-  ///     top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the
-  ///     execution of
-  ///     the body of the loop. The top integer is the "destination index" and the second integer is the "current index."
-  ///     Last the code
-  ///     and the integer arguments are saved locally and popped. Then the integers are compared. If the integers are equal
-  ///     then the current
-  ///     index is pushed onto the INTEGER stack and the code (which is the "body" of the loop) is pushed onto the EXEC stack
-  ///     for subsequent
-  ///     execution. If the integers are not equal then the current index will still be pushed onto the INTEGER stack but two
-  ///     items will be
-  ///     pushed onto the EXEC stack -- first a recursive call to CODE.DO*RANGE (with the same code and destination index,
-  ///     but with a current
-  ///     index that has been either incremented or decremented by 1 to be closer to the destination index) and then the body
-  ///     code. Note that
-  ///     the range is inclusive of both endpoints; a call with integer arguments 3 and 5 will cause its body to be executed
-  ///     3 times, with the
-  ///     loop counter having the values 3, 4, and 5. Note also that one can specify a loop that "counts down" by providing a
-  ///     destination index
-  ///     that is less than the specified current index.
+  /// An iteration instruction that executes the top item on the CODE stack a number of times that depends on the
+  /// top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the
+  /// execution of the body of the loop. The top integer is the "destination index" and the second integer is the "current index."
+  /// Last the code and the integer arguments are saved locally and popped. Then the integers are compared. If the integers are equal
+  /// then the current index is pushed onto the INTEGER stack and the code (which is the "body" of the loop) is pushed onto the EXEC stack
+  /// for subsequent execution. If the integers are not equal then the current index will still be pushed onto the INTEGER stack but two
+  /// items will be pushed onto the EXEC stack -- first a recursive call to CODE.DO*RANGE (with the same code and destination index,
+  /// but with a current index that has been either incremented or decremented by 1 to be closer to the destination index) and then the body
+  /// code. Note that the range is inclusive of both endpoints; a call with integer arguments 3 and 5 will cause its body to be executed
+  /// 3 times, with the loop counter having the values 3, 4, and 5. Note also that one can specify a loop that "counts down" by providing a
+  /// destination index that is less than the specified current index.
   /// </summary>
   [Serializable]
   [StorableClass]
   [PushExpression(StackTypes.Code, "CODE.DO*RANGE", StackTypes.Integer)]
-  public class CodeDoRangeExpression : DoRangeExpression {
+  public class CodeDoRangeExpression : StatelessExpression {
     public CodeDoRangeExpression() { }
-    public CodeDoRangeExpression(LoopState state) : base(state) { }
     [StorableConstructor]
     protected CodeDoRangeExpression(bool deserializing) : base(deserializing) { }
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return State.Body == null && HasInsufficientArguments(interpreter, interpreter.CodeStack);
+      return interpreter.IntegerStack.Count < 2 || interpreter.CodeStack.IsEmpty;
     }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.CodeStack);
-    }
+      var toDo = interpreter.CodeStack.Pop();
+      var currentIndex = interpreter.IntegerStack[1];
+      var destinationIndex = interpreter.IntegerStack[0];
 
-    protected override LoopExpression Clone(LoopState state, IInternalPushInterpreter interpreter) {
-      var expression = interpreter.PoolContainer.GetStatefulExpression<CodeDoRangeExpression>();
-      expression.State = state;
+      interpreter.IntegerStack.Pop();
 
-      return expression;
+      if (currentIndex != destinationIndex) {
+
+        var incrementor = currentIndex < destinationIndex ? 1 : -1;
+        var continuation = interpreter.PoolContainer.ExpressionListPool.Get();
+        var pool = interpreter.PoolContainer.GetStatefulExpressionPool<IntegerPushExpression>();
+
+        continuation.Add(this);
+        continuation.Add(toDo);
+        continuation.Add(ExpressionTable.GetStatelessExpression<CodeQuoteExpression>());
+        continuation.Add(IntegerPushExpression.Create(pool, destinationIndex));
+        continuation.Add(IntegerPushExpression.Create(pool, currentIndex + incrementor));
+
+        var program = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, continuation);
+        interpreter.ExecStack.Push(program);
+      }
+
+      interpreter.ExecStack.Push(toDo);
     }
   }
@@ -84,48 +60,50 @@
   /// <summary>
   ///     An iteration instruction that executes the top item on the EXEC stack a number of times that depends on the top two
-  ///     integers,
-  ///     while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of
-  ///     the loop.
-  ///     This is similar to CODE.DO*COUNT except that it takes its code argument from the EXEC stack. The top integer is the
+  ///     integers, while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of
+  ///     the loop. This is similar to CODE.DO*COUNT except that it takes its code argument from the EXEC stack. The top integer is the
   ///     "destination index" and the second integer is the "current index." Last the code and the integer arguments are
-  ///     saved locally
-  ///     and popped. Then the integers are compared. If the integers are equal then the current index is pushed onto the
-  ///     INTEGER stack
-  ///     and the code (which is the "body" of the loop) is pushed onto the EXEC stack for subsequent execution. If the
-  ///     integers are not
-  ///     equal then the current index will still be pushed onto the INTEGER stack but two items will be pushed onto the EXEC
-  ///     stack
-  ///     -- first a recursive call to EXEC.DO*RANGE (with the same code and destination index, but with a current index that
-  ///     has been
-  ///     either incremented or decremented by 1 to be closer to the destination index) and then the body code. Note that the
-  ///     range is
-  ///     inclusive of both endpoints; a call with integer arguments 3 and 5 will cause its body to be executed 3 times, with
-  ///     the loop
-  ///     counter having the values 3, 4, and 5. Note also that one can specify a loop that "counts down" by providing a
-  ///     destination
-  ///     index that is less than the specified current index.
+  ///     saved locally and popped. Then the integers are compared. If the integers are equal then the current index is pushed onto the
+  ///     INTEGER stack and the code (which is the "body" of the loop) is pushed onto the EXEC stack for subsequent execution. If the
+  ///     integers are not equal then the current index will still be pushed onto the INTEGER stack but two items will be pushed onto the EXEC
+  ///     stack -- first a recursive call to EXEC.DO*RANGE (with the same code and destination index, but with a current index that
+  ///     has been either incremented or decremented by 1 to be closer to the destination index) and then the body code. Note that the
+  ///     range is inclusive of both endpoints; a call with integer arguments 3 and 5 will cause its body to be executed 3 times, with
+  ///     the loop counter having the values 3, 4, and 5. Note also that one can specify a loop that "counts down" by providing a
+  ///     destination index that is less than the specified current index.
   /// </summary>
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DO*RANGE", StackTypes.Integer)]
-  public class ExecDoRangeExpression : DoRangeExpression {
+  [PushExpression(StackTypes.Exec, "EXEC.DO*RANGE", StackTypes.Integer, execIn: 1)]
+  public class ExecDoRangeExpression : StatelessExpression {
     public ExecDoRangeExpression() { }
 
-    public ExecDoRangeExpression(LoopState state) : base(state) { }
     [StorableConstructor]
     protected ExecDoRangeExpression(bool deserializing) : base(deserializing) { }
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return State.Body == null && HasInsufficientArguments(interpreter, interpreter.ExecStack);
+      return interpreter.IntegerStack.Count < 2 || interpreter.ExecStack.IsEmpty;
     }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.ExecStack);
-    }
-    protected override LoopExpression Clone(LoopState state, IInternalPushInterpreter interpreter) {
-      var expression = interpreter.PoolContainer.GetStatefulExpression<ExecDoRangeExpression>();
-      expression.State = state;
+      var currentIndex = interpreter.IntegerStack[1];
+      var destinationIndex = interpreter.IntegerStack[0];
 
-      return expression;
+      interpreter.IntegerStack.Pop();
+
+      if (currentIndex == destinationIndex)
+        return;
+
+      var toDo = interpreter.ExecStack.Top;
+      var incrementor = currentIndex < destinationIndex ? 1 : -1;
+      var continuation = interpreter.PoolContainer.ExpressionListPool.Get();
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<IntegerPushExpression>();
+
+      continuation.Add(toDo);
+      continuation.Add(this);
+      continuation.Add(IntegerPushExpression.Create(pool, destinationIndex));
+      continuation.Add(IntegerPushExpression.Create(pool, currentIndex + incrementor));
+
+      interpreter.ExecStack.Top = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, continuation);
+      interpreter.ExecStack.Push(toDo);
     }
   }
